﻿using UnityEngine;
using System.Linq;
using System.Collections;
using System.Collections.Generic;
using HarmonyLib;
using System.Reflection;
using UnityEngine.UI;
using UnityEngine.SceneManagement;
using Steamworks;

public class DiagonalPillars : Mod
{
    static List<GameObject> addedObjects = new List<GameObject>();
    static Dictionary<Item_Base,List<Item_Base>> addedItems;
    static List<group> groups = new List<group>();
    static List<Item_Base> createdItems = new List<Item_Base>();
    static List<Sprite> createdSprites = new List<Sprite>();
    static Transform prefabParent;
    static Button unloadButton;
    static Button.ButtonClickedEvent eventStore = null;
    static JsonModInfo info;
    static bool CanUnload
    {
        get { return eventStore == null; }
        set
        {
            if (!value && eventStore == null)
            {
                eventStore = unloadButton.onClick;
                unloadButton.onClick = new Button.ButtonClickedEvent();
                unloadButton.onClick.AddListener(delegate { Debug.LogError($"[{info.name}]: Mod cannot be unloaded while in a multiplayer"); });
            }
            else if (value && eventStore != null)
            {
                unloadButton.onClick = eventStore;
                eventStore = null;
            }
        }
    }
    Harmony harmony;
    static bool loaded = false;
    public void Start()
    {
        info = modlistEntry.jsonmodinfo;
        unloadButton = modlistEntry.modinfo.unloadBtn.GetComponent<Button>();
        if (SceneManager.GetActiveScene().name == Semih_Network.GameSceneName && ComponentManager<Semih_Network>.Value.remoteUsers.Count > 1)
        {
            Debug.LogError($"[{info.name}]: This cannot be loaded in multiplayer");
            unloadButton.onClick.Invoke();
            return;
        }
        loaded = true;
        harmony = new Harmony("com.aidanamite.DiagonalPillars");
        harmony.PatchAll();
        addedItems = new Dictionary<Item_Base, List<Item_Base>>();
        prefabParent = new GameObject("prefabParent").transform;
        prefabParent.gameObject.SetActive(false);
        DontDestroyOnLoad(prefabParent.gameObject);
        var index = 4200;
        foreach (var i in new Item_Base[] {
            ItemManager.GetItemByName("Block_Pillar_Wood"),
            ItemManager.GetItemByName("Block_HalfPillar_Wood"),
            ItemManager.GetItemByName("Block_Pillar_Tier3"),
            ItemManager.GetItemByName("Block_Pillar_Tier3_Half") })
        {
            var n = new List<Item_Base>();
            addedItems.Add(i, n);
            var newItem = i.Clone(index++, i.UniqueName + "_Diagonal");
            n.Add(newItem);
            var sprite = newItem.settings_Inventory.Sprite.GetReadable(true);
            var t = sprite.texture;
            var ot = t.GetReadable();
                for (int x = 0; x < t.width; x++)
                    for (int y = 0; y < t.height; y++)
                        t.SetPixel(x, y, ot.GetPixel((x + (y - t.height / 2) / 4).Mod(t.width), y).Correct());
            t.Apply();
            createdSprites.Add(sprite);
            newItem.settings_Inventory.Sprite = sprite;
            var prefabs = new List<Block>(newItem.settings_buildable.GetBlockPrefabs()).ToArray();
            for (int j = 0; j < prefabs.Length; j++)
            {
                prefabs[j] = Instantiate(prefabs[j], prefabParent);
                foreach (Transform c in prefabs[j].transform)
                {
                    var scale = c.localScale;
                    scale.Scale(new Vector3(1, new Vector2(BlockCreator.HalfFloorHeight, BlockCreator.BlockSize).magnitude / BlockCreator.HalfFloorHeight, 1));
                    c.localScale = scale;
                    c.RotateAround(Vector3.zero, Vector3.right, Mathf.Atan(BlockCreator.BlockSize / (BlockCreator.HalfFloorHeight - 0.1f)) / Mathf.PI * 180);
                }
                prefabs[j].colliderPrefab = Instantiate(prefabs[j].colliderPrefab, prefabParent);
                
                prefabs[j].buildableItem = newItem;
                foreach (var quad in prefabs[j].colliderPrefab.GetComponentsInChildren<BlockQuad>(true))
                    quad.transform.localPosition = quad.transform.localPosition.offsetZByY();
                /*if (modified.TryGetValue(prefabs[j].blockCollisionMask, out var v))
                    prefabs[j].blockCollisionMask = v;
                else {
                    prefabs[j].blockCollisionMask = Instantiate(prefabs[j].blockCollisionMask);
                    prefabs[j].blockCollisionMask.exceptSelf = false;
                }*/
                /*foreach (var r in prefabs[j].GetComponentsInChildren<MeshFilter>())
                {
                    var mesh = new Mesh();
                    var v = new List<Vector3>();
                    r.mesh.GetVertices(v);
                    mesh.vertices = v.ToArray();
                    var p = new List<int>();
                    r.mesh.GetTriangles(p, 0);
                    mesh.triangles = p.ToArray();
                    var u = new List<Vector2>();
                    r.mesh.GetUVs(0, u);
                    mesh.uv = u.ToArray();
                    for (int k = 0; k < mesh.vertices.Length; k++)
                        mesh.vertices[k] = mesh.vertices[k].offsetByY();
                    mesh.RecalculateBounds();
                    r.sharedMesh = mesh;
                    createdMesh.Add(mesh);
                }*/
            }
            Traverse.Create(newItem.settings_buildable).Field("blockPrefabs").SetValue(prefabs);
            RAPI.RegisterItem(newItem);
            createdItems.Add(newItem);
            foreach (var type in Resources.FindObjectsOfTypeAll<SO_BlockQuadType>())
                if (type.AcceptsBlock(i))
                    Traverse.Create(type).Field("acceptableBlockTypes").GetValue<List<Item_Base>>().Add(newItem);

            // ---------------------------

            newItem = i.Clone(index++, i.UniqueName + "_Diagonal2");
            n.Add(newItem);
            sprite = newItem.settings_Inventory.Sprite.GetReadable(true);
            t = sprite.texture;
            ot = t.GetReadable();
                for (int x = 0; x < t.width; x++)
                    for (int y = 0; y < t.height; y++)
                        t.SetPixel(x, y, ot.GetPixel((x + (y - t.height / 2) / 2).Mod(t.width), y).Correct());
            t.Apply();
            createdSprites.Add(sprite);
            newItem.settings_Inventory.Sprite = sprite;
            prefabs = new List<Block>(newItem.settings_buildable.GetBlockPrefabs()).ToArray();
            for (int j = 0; j < prefabs.Length; j++)
            {
                prefabs[j] = Instantiate(prefabs[j], prefabParent);
                foreach (Transform c in prefabs[j].transform)
                {
                    var scale = c.localScale;
                    scale.Scale(new Vector3(1, new Vector3(BlockCreator.BlockSize, BlockCreator.HalfFloorHeight, BlockCreator.BlockSize).magnitude / BlockCreator.HalfFloorHeight, 1));
                    c.localScale = scale;
                    c.RotateAround(Vector3.zero, Vector3.right, Mathf.Atan(Mathf.Sqrt(Mathf.Pow(BlockCreator.BlockSize, 2) * 2) / (BlockCreator.HalfFloorHeight - 0.1f)) / Mathf.PI * 180);
                    c.transform.RotateAround(Vector3.zero, Vector3.up, 45);
                }
                prefabs[j].colliderPrefab = Instantiate(prefabs[j].colliderPrefab, prefabParent);

                prefabs[j].buildableItem = newItem;
                foreach (var quad in prefabs[j].colliderPrefab.GetComponentsInChildren<BlockQuad>(true))
                    quad.transform.localPosition = quad.transform.localPosition.offsetZByY().offsetXByY();
            }
            Traverse.Create(newItem.settings_buildable).Field("blockPrefabs").SetValue(prefabs);
            RAPI.RegisterItem(newItem);
            createdItems.Add(newItem);
            foreach (var type in Resources.FindObjectsOfTypeAll<SO_BlockQuadType>())
                if (type.AcceptsBlock(i))
                    Traverse.Create(type).Field("acceptableBlockTypes").GetValue<List<Item_Base>>().Add(newItem);
        }
        InsertOptions();
        CanvasHelper.MenuOpenEvent += InsertOptions;
        Log("Mod has been loaded!");
    }

    static void CheckUnload() => CanUnload = SceneManager.GetActiveScene().name != Semih_Network.GameSceneName || ComponentManager<Semih_Network>.Value.remoteUsers.Count <= 1;

    public override void WorldEvent_OnPlayerConnected(CSteamID steamid, RGD_Settings_Character characterSettings) => CheckUnload();
    public override void WorldEvent_OnPlayerDisconnected(CSteamID steamid, DisconnectReason disconnectReason) => CheckUnload();
    public override void WorldEvent_WorldLoaded() => CheckUnload();
    public override void WorldEvent_WorldUnloaded() => CheckUnload();

    public void OnModUnload()
    {
        if (!loaded)
            return;
        loaded = false;
        harmony.UnpatchAll(harmony.Id);
        CanvasHelper.MenuOpenEvent -= InsertOptions;
        RemoveOptions();
        List<Item_Base> items = Traverse.Create(typeof(ItemManager)).Field("allAvailableItems").GetValue<List<Item_Base>>();
        items.RemoveAll((x) => createdItems.Contains(x));
        foreach (var i in createdItems)
        {
            foreach (var type in Resources.FindObjectsOfTypeAll<SO_BlockQuadType>())
                if (type.AcceptsBlock(i))
                    Traverse.Create(type).Field("acceptableBlockTypes").GetValue<List<Item_Base>>().RemoveAll((x) => x.UniqueName == i.UniqueName);
            Destroy(i);
        }
        createdItems.Clear();
        foreach (var s in createdSprites)
        {
            if (!s)
                continue;
            if (s.texture)
                Destroy(s.texture);
            Destroy(s);
        }
        createdSprites.Clear();
        Destroy(prefabParent.gameObject);
        Log("Mod has been unloaded!");
    }

    public static void InsertOptions(MenuType type = MenuType.None)
    {
        if (addedObjects.Contains(null))
            RemoveOptions();
        else if (addedObjects.Count != 0)
            return;
        var helper = ComponentManager<CanvasHelper>.Value;
        if (!helper) return;
        var menu = helper.GetMenu(MenuType.BuildMenu);
        if (menu == null || !menu.IsOpen || menu.menuObjects.Count == 0) return;
        var hP = menu.menuObjects[0].transform.Find("RightPanel/LayoutGroup");
        Transform last = null;
        foreach (Transform mP in hP)
            foreach (Transform hC in mP.Find("HorizontalParent"))
                if (hC.name.Contains("Parent"))
                    foreach (RectTransform vC in hC.Find("VerticalParent"))
                    {
                        if (last != vC.parent)
                        {
                            groups.Insert(0, new group());
                            last = vC.parent;
                        }
                        if (vC.name == "CategoryBackground")
                        {
                            groups[0].background = vC;
                            continue;
                        }
                        groups[0].objects++;
                        groups[0].baseObjects++;
                        if (!vC.GetComponent<BuildMenuItem_SelectBlock>()) continue;
                        var i = Traverse.Create(vC.GetComponent<BuildMenuItem_SelectBlock>()).Field("buildableItem").GetValue<Item_Base>();
                        if (!i || !addedItems.TryGetValue(i, out var items)) continue;
                        foreach (var item in items)
                        {
                            var g = Instantiate(vC, vC.parent, false).GetComponent<BuildMenuItem_SelectBlock>();
                            addedObjects.Add(g.gameObject);
                            Traverse.Create(g).Field("buildableItem").SetValue(item);
                            Traverse.Create(g).Method("RefreshIcon").GetValue();
                            groups[0].objects++;
                        }
                    }
        foreach (var g in groups)
        {
            var o = g.background.offsetMin.y;
            var h = (g.background.offsetMin.y - g.background.offsetMax.y - 70) / g.baseObjects * g.objects;
            g.background.offsetMin = new Vector2(g.background.offsetMin.x, g.background.offsetMax.y + h + 70);
            g.difference = g.background.offsetMin.y - o;
        }
    }
    public static void RemoveOptions()
    {
        foreach (var o in addedObjects)
            if (o)
                Destroy(o);
        addedObjects.Clear();
        foreach (var g in groups)
            if (g.background)
                g.background.offsetMin -= new Vector2(0,g.difference);
        groups.Clear();
    }
}

class group
{
    public RectTransform background;
    public int objects = 0;
    public int baseObjects = 0;
    public float difference;
}

static class ExtentionMethods
{
    public static Y Join<X, Y>(this IEnumerable<X> collection, System.Func<X, Y> converter, System.Func<Y, Y, Y> joiner) => (collection as IEnumerable).Join(converter, joiner);
    public static Y Join<X,Y>(this IEnumerable collection, System.Func<X,Y> converter, System.Func<Y,Y,Y> joiner)
    {
        bool first = false;
        Y r = default(Y);
        foreach (X v in collection)
            if (first)
                r = joiner(r, converter(v));
            else
            {
                r = converter(v);
                first = true;
            }
        return r;
    }
    public static bool Exists<T>(this IEnumerable<T> collection, System.Predicate<T> match) => (collection as IEnumerable).Exists(match);
    public static bool Exists<T>(this IEnumerable collection, System.Predicate<T> match)
    {
        foreach (T v in collection)
            if (match(v))
                return true;
        return false;
    }
    public static Sprite GetReadable(this Sprite source, bool resize = false)
    {
        var t = source.texture.GetReadable();
        return Sprite.Create(t, resize ? new Rect(0,0,t.width,t.height) : source.rect, source.pivot, source.pixelsPerUnit);
    }

    public static Texture2D GetReadable(this Texture2D source)
    {
        RenderTexture temp = RenderTexture.GetTemporary(source.width, source.height, 0, RenderTextureFormat.Default, RenderTextureReadWrite.Linear);
        Graphics.Blit(source, temp);
        RenderTexture prev = RenderTexture.active;
        RenderTexture.active = temp;
        Texture2D texture = new Texture2D(source.width, source.height);
        texture.ReadPixels(new Rect(0, 0, temp.width, temp.height), 0, 0, true);
        texture.Apply();
        RenderTexture.active = prev;
        RenderTexture.ReleaseTemporary(temp);
        return texture;
    }
    public static Item_Base Clone(this Item_Base source, int uniqueIndex, string uniqueName)
    {
        Item_Base item = ScriptableObject.CreateInstance<Item_Base>();
        item.Initialize(uniqueIndex, uniqueName, source.MaxUses);
        item.settings_buildable = source.settings_buildable.Clone();
        item.settings_consumeable = source.settings_consumeable.Clone();
        item.settings_cookable = source.settings_cookable.Clone();
        item.settings_equipment = source.settings_equipment.Clone();
        item.settings_Inventory = source.settings_Inventory.Clone();
        item.settings_recipe = source.settings_recipe.Clone();
        item.settings_usable = source.settings_usable.Clone();
        return item;
    }

    public static void SetRecipe(this ItemInstance_Recipe item, CostMultiple[] cost, int amountToCraft = 1)
    {
        Traverse.Create(item).Field("amountToCraft").SetValue(amountToCraft);
        item.NewCost = cost;
    }
    public static int Mod(this int a, int b) => a % b + (b < 0 == a < 0 ? 0 : a);
    public static Vector3 offsetZByY(this Vector3 v) => new Vector3(v.x, v.y, v.z + v.y / BlockCreator.HalfFloorHeight * BlockCreator.BlockSize);
    public static Vector3 offsetXByY(this Vector3 v) => new Vector3(v.x + v.y / BlockCreator.HalfFloorHeight * BlockCreator.BlockSize, v.y, v.z);

    public static List<FieldInfo> FindAllFields(this object obj)
    {
        var t = obj.GetType();
        var l = new List<FieldInfo>();
        do
        {
            foreach (var f in t.GetFields((BindingFlags)(-1)))
                if (!f.IsStatic)
                    l.Add(f);
            t = t.BaseType;
        } while (t != typeof(object));
        return l;
    }
    public static Color Correct(this Color c)
    {
        return new Color(Mathf.Pow(c.r, 1 / 3.5f) * 1.2f, Mathf.Pow(c.g, 1 / 3.5f) * 1.2f, Mathf.Pow(c.b, 1 / 3.5f) * 1.2f, c.a);
    }
}

[HarmonyPatch]
class Patch_CollisionCheck
{
    static List<MethodBase> TargetMethods() => typeof(Helper).GetMethods((BindingFlags)(-1)).Cast<MethodBase>().ToList().FindAll((x) => x.Name == "GetCollisions").ToList();
    public static BoxCollider calling;
    static void Prefix(BoxCollider col) => calling = col;
    static void Postfix() => calling = null;
}

[HarmonyPatch]
class Patch_OverlapCheck
{
    static List<MethodBase> TargetMethods() => typeof(Physics).GetMethods((BindingFlags)(-1)).Cast<MethodBase>().ToList().FindAll((x) => x.Name == "OverlapBox").ToList();
    static void Prefix(ref Vector3 center)
    {
        if (Patch_CollisionCheck.calling)
            center = Patch_CollisionCheck.calling.transform.TransformPoint(Patch_CollisionCheck.calling.center);
    }
}